extern BOOL __internal_drag_and_drop;
extern NSString* dragDropControllerInternalPboardType;

void listInsertObjectBefore (NSMutableArray* ls, NSArray* objects, id before);
void listInsertObjectAfter (NSMutableArray* ls, NSArray* objects, id after);
void listStoreOrder(NSArray* ls, NSString* key);
void listStoreOrderRecursive(NSArray* ls, NSString* key, NSString* ckey);

NSMutableArray* listPrepareReorder(NSArray* allitems, NSArray* newitems, NSString* key);

@interface MYDragController : NSObject {
	id lastDropDestination;
	id lastDropSource;
	id lastDropObject;
	NSInteger lastDropOperation;
	
	IBOutlet NSWindow* dialogParent;
}

@property (assign) BOOL fileDialogCanChooseDirectories;

- (void) fileURLsAddedFromDialog:(NSArray*) ls;
- (IBAction) addFileFromDialog:(id) sender;
- (IBAction) readFromPasteboard:(id) sender;

- (BOOL) writeObjects:(NSArray*)ls toPasteboard:(NSPasteboard*) pboard;

@end

